
#ifdef YY_QUERY_API_VER
#define YY_BYACCIC
#define YY_API_MAJOR 1
#define YY_API_MINOR 0
#endif /*YY_QUERY_API_VER*/

#define calc_EMPTY        (-1)
#define calc_clearin      (calc_chr = calc_EMPTY)
#define calc_errok        (calc_errflag = 0)
#define calc_RECOVERING() (calc_errflag != 0)
#define calc_ENOMEM       (-2)
#define calc_EOF          0
#define calc_chr yyctx->chr
#define calc_val yyctx->val
#define calc_lval yyctx->lval
#define calc_stack yyctx->stack
#define calc_debug yyctx->debug
#define calc_nerrs yyctx->nerrs
#define calc_errflag yyctx->errflag
#define calc_state yyctx->state
#define calc_yyn yyctx->yyn
#define calc_yym yyctx->yym
#define calc_jump yyctx->jump
#line 4 "calc.y"
# include <stdio.h>
# include <ctype.h>

typedef struct {
	int regs[26];
	int base;
} calc_ctx_t;

#line 35 "calc.c"
typedef int calc_STYPE;

#define DIGIT 257
#define LETTER 258
#define UMINUS 259
#define calc_ERRCODE 256
typedef short calc_int_t;
static const calc_int_t calc_lhs[] = {                        -1,
    0,    0,    0,    1,    1,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    3,    3,
};
static const calc_int_t calc_len[] = {                         2,
    0,    3,    3,    1,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    2,    1,    1,    1,    2,
};
static const calc_int_t calc_defred[] = {                      1,
    0,    0,   17,    0,    0,    0,    0,    0,    0,    3,
    0,   15,   14,    0,    2,    0,    0,    0,    0,    0,
    0,    0,   18,    0,    6,    0,    0,    0,    0,    9,
   10,   11,
};
static const calc_int_t calc_dgoto[] = {                       1,
    7,    8,    9,
};
static const calc_int_t calc_sindex[] = {                      0,
  -40,   -7,    0,  -55,  -38,  -38,    1,  -29, -247,    0,
  -38,    0,    0,   22,    0,  -38,  -38,  -38,  -38,  -38,
  -38,  -38,    0,  -29,    0,   51,   60,  -20,  -20,    0,
    0,    0,
};
static const calc_int_t calc_rindex[] = {                      0,
    0,    0,    0,    2,    0,    0,    0,    9,   -9,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   10,    0,   -6,   14,    5,   13,    0,
    0,    0,
};
static const calc_int_t calc_gindex[] = {                      0,
    0,   65,    0,
};
#define calc_TABLESIZE 220
static const calc_int_t calc_table[] = {                       6,
   16,    6,   10,   13,    5,   11,    5,   22,   17,   23,
   15,   15,   20,   18,    7,   19,   22,   21,    4,    5,
    0,   20,    8,   12,    0,    0,   21,   16,   16,    0,
    0,   16,   16,   16,   13,   16,    0,   16,   15,   15,
    0,    0,    7,   15,   15,    7,   15,    7,   15,    7,
    8,   12,    0,    8,   12,    8,    0,    8,   22,   17,
    0,    0,   25,   20,   18,    0,   19,    0,   21,   13,
   14,    0,    0,    0,    0,   24,    0,    0,    0,    0,
   26,   27,   28,   29,   30,   31,   32,   22,   17,    0,
    0,    0,   20,   18,   16,   19,   22,   21,    0,    0,
    0,   20,   18,    0,   19,    0,   21,    0,    0,    0,
    0,    0,    0,    0,   16,    0,    0,   13,    0,    0,
    0,    0,    0,    0,    0,   15,    0,    0,    7,    0,
    0,    0,    0,    0,    0,    0,    8,   12,    0,    0,
    0,    0,    0,    0,    0,   16,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    2,    3,    4,    3,   12,
};
static const calc_int_t calc_check[] = {                      40,
   10,   40,   10,   10,   45,   61,   45,   37,   38,  257,
   10,   10,   42,   43,   10,   45,   37,   47,   10,   10,
   -1,   42,   10,   10,   -1,   -1,   47,   37,   38,   -1,
   -1,   41,   42,   43,   41,   45,   -1,   47,   37,   38,
   -1,   -1,   38,   42,   43,   41,   45,   43,   47,   45,
   38,   38,   -1,   41,   41,   43,   -1,   45,   37,   38,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,    5,
    6,   -1,   -1,   -1,   -1,   11,   -1,   -1,   -1,   -1,
   16,   17,   18,   19,   20,   21,   22,   37,   38,   -1,
   -1,   -1,   42,   43,  124,   45,   37,   47,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  124,   -1,   -1,  124,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   -1,   -1,  124,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  124,  124,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  124,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  256,  257,  258,  257,  258,
};
#define calc_FINAL 1
#define calc_MAXTOKEN 259
#define calc_UNDFTOKEN 265
#define calc_TRANSLATE(a) ((a) > calc_MAXTOKEN ? calc_UNDFTOKEN : (a))
#if calc_DEBUG
static const char *const calc_name[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'",0,"'-'",0,"'/'",0,0,0,0,0,0,0,
0,0,0,0,0,0,"'='",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'|'",0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"DIGIT","LETTER","UMINUS",0,0,0,0,0,"illegal-symbol",
};
static const char *const calc_rule[] = {
"$accept : list",
"list :",
"list : list stat '\\n'",
"list : list error '\\n'",
"stat : expr",
"stat : LETTER '=' expr",
"expr : '(' expr ')'",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : expr '*' expr",
"expr : expr '/' expr",
"expr : expr '%' expr",
"expr : expr '&' expr",
"expr : expr '|' expr",
"expr : '-' expr",
"expr : LETTER",
"expr : number",
"number : DIGIT",
"number : number DIGIT",

};
#endif


#ifndef calc_INITSTACKSIZE
#define calc_INITSTACKSIZE 200
#endif

typedef struct {
	unsigned stacksize;
	calc_int_t *s_base;
	calc_int_t *s_mark;
	calc_int_t *s_last;
	calc_STYPE *l_base;
	calc_STYPE *l_mark;
#if calc_DEBUG
	int debug;
#endif
} calc_STACKDATA;

typedef struct {
	int errflag;
	int chr;
	calc_STYPE val;
	calc_STYPE lval;
	int nerrs;
	int yym, yyn, state;
	int jump;
	int stack_max_depth;

	/* variables for the parser stack */
	calc_STACKDATA stack;
} calc_yyctx_t;

typedef enum { calc_RES_NEXT, calc_RES_DONE, calc_RES_ABORT } calc_res_t;

extern int calc_parse_init(calc_yyctx_t *yyctx);
extern calc_res_t calc_parse(calc_yyctx_t *yyctx, calc_ctx_t *ctx, int tok, calc_STYPE *lval);
extern void calc_error(calc_ctx_t *ctx, calc_STYPE tok, const char *msg);

#line 67 "calc.y"
 /* start of programs */

static int lex(calc_ctx_t *ctx, calc_STYPE *yylval)
{
	/* lexical analysis routine */
	/* returns LETTER for a lower case letter, *yylval = 0 through 25 */
	/* return DIGIT for a digit, *yylval = 0 through 9 */
	/* all other characters are returned immediately */

	int c;
	while( (c=getchar()) == ' ' )   { /* skip blanks */ }

	/* c is now nonblank */
	if (islower(c)) {
		*yylval = c - 'a';
		return LETTER;
	}
	if (isdigit(c)) {
		*yylval = c - '0';
		return DIGIT;
	}
	return(c);
}

int main(void)
{
	calc_ctx_t ctx;
	calc_yyctx_t yyctx;

	if (calc_parse_init(&yyctx) != 0)
		return -1;

	for(;;) {
		int tok, res;
		calc_STYPE lval;

		if (feof(stdin)) {
			printf("<feof>\n");
			break;
		}
		tok = lex(&ctx, &lval);
		res = calc_parse(&yyctx, &ctx, tok, &lval);
	}
	return 0;
}

void calc_error(calc_ctx_t *ctx, calc_STYPE tok, const char *s)
{
	fprintf(stderr, "%s\n", s);
}

#line 252 "calc.c"

#if calc_DEBUG
#include <stdio.h> /* needed for printf */
#endif

#include <stdlib.h> /* needed for malloc, etc */
#include <string.h> /* needed for memset */

/* allocate initial stack or double stack size, up to yyctx->stack_max_depth */
static int calc_growstack(calc_yyctx_t *yyctx, calc_STACKDATA *data)
{
	int i;
	unsigned newsize;
	calc_int_t *newss;
	calc_STYPE *newvs;

	if ((newsize = data->stacksize) == 0)
		newsize = calc_INITSTACKSIZE;
	else if (newsize >= yyctx->stack_max_depth)
		return calc_ENOMEM;
	else if ((newsize *= 2) > yyctx->stack_max_depth)
		newsize = yyctx->stack_max_depth;

	i = (int)(data->s_mark - data->s_base);
	newss = (calc_int_t *) realloc(data->s_base, newsize * sizeof(*newss));
	if (newss == 0)
		return calc_ENOMEM;

	data->s_base = newss;
	data->s_mark = newss + i;

	newvs = (calc_STYPE *) realloc(data->l_base, newsize * sizeof(*newvs));
	if (newvs == 0)
		return calc_ENOMEM;

	data->l_base = newvs;
	data->l_mark = newvs + i;

	data->stacksize = newsize;
	data->s_last = data->s_base + newsize - 1;
	return 0;
}

static void calc_freestack(calc_STACKDATA *data)
{
	free(data->s_base);
	free(data->l_base);
	memset(data, 0, sizeof(*data));
}

#define calc_ABORT  goto yyabort
#define calc_REJECT goto yyabort
#define calc_ACCEPT goto yyaccept
#define calc_ERROR  goto yyerrlab

int calc_parse_init(calc_yyctx_t *yyctx)
{
#if calc_DEBUG
	const char *yys;

	if ((yys = getenv("calc_DEBUG")) != 0) {
		yyctx->yyn = *yys;
		if (yyctx->yyn >= '0' && yyctx->yyn <= '9')
			yyctx->debug = yyctx->yyn - '0';
	}
#endif

	memset(&yyctx->val, 0, sizeof(yyctx->val));
	memset(&yyctx->lval, 0, sizeof(yyctx->lval));

	yyctx->yym = 0;
	yyctx->yyn = 0;
	yyctx->nerrs = 0;
	yyctx->errflag = 0;
	yyctx->chr = calc_EMPTY;
	yyctx->state = 0;

	memset(&yyctx->stack, 0, sizeof(yyctx->stack));

	yyctx->stack_max_depth = calc_INITSTACKSIZE > 10000 ? calc_INITSTACKSIZE : 10000;
	if (yyctx->stack.s_base == NULL && calc_growstack(yyctx, &yyctx->stack) == calc_ENOMEM)
		return -1;
	yyctx->stack.s_mark = yyctx->stack.s_base;
	yyctx->stack.l_mark = yyctx->stack.l_base;
	yyctx->state = 0;
	*yyctx->stack.s_mark = 0;
	yyctx->jump = 0;
	return 0;
}


#define calc_GETCHAR(labidx) \
do { \
	if (used)               { yyctx->jump = labidx; return calc_RES_NEXT; } \
	getchar_ ## labidx:;    yyctx->chr = tok; yyctx->lval = *lval; used = 1; \
} while(0)

calc_res_t calc_parse(calc_yyctx_t *yyctx, calc_ctx_t *ctx, int tok, calc_STYPE *lval)
{
	int used = 0;
#if calc_DEBUG
	const char *yys;
#endif

yyloop:;
	if (yyctx->jump == 1) { yyctx->jump = 0; goto getchar_1; }
	if (yyctx->jump == 2) { yyctx->jump = 0; goto getchar_2; }

	if ((yyctx->yyn = calc_defred[yyctx->state]) != 0)
		goto yyreduce;
	if (yyctx->chr < 0) {
		calc_GETCHAR(1);
		if (yyctx->chr < 0)
			yyctx->chr = calc_EOF;
#if calc_DEBUG
		if (yyctx->debug) {
			if ((yys = calc_name[calc_TRANSLATE(yyctx->chr)]) == NULL)
				yys = calc_name[calc_UNDFTOKEN];
			printf("yyctx->debug: state %d, reading %d (%s)\n", yyctx->state, yyctx->chr, yys);
		}
#endif
	}
	if (((yyctx->yyn = calc_sindex[yyctx->state]) != 0) && (yyctx->yyn += yyctx->chr) >= 0 && yyctx->yyn <= calc_TABLESIZE && calc_check[yyctx->yyn] == (calc_int_t) yyctx->chr) {
#if calc_DEBUG
		if (yyctx->debug)
			printf("yyctx->debug: state %d, shifting to state %d\n", yyctx->state, calc_table[yyctx->yyn]);
#endif
		if (yyctx->stack.s_mark >= yyctx->stack.s_last && calc_growstack(yyctx, &yyctx->stack) == calc_ENOMEM)
			goto yyoverflow;
		yyctx->state = calc_table[yyctx->yyn];
		*++yyctx->stack.s_mark = calc_table[yyctx->yyn];
		*++yyctx->stack.l_mark = yyctx->lval;
		yyctx->chr = calc_EMPTY;
		if (yyctx->errflag > 0)
			--yyctx->errflag;
		goto yyloop;
	}
	if (((yyctx->yyn = calc_rindex[yyctx->state]) != 0) && (yyctx->yyn += yyctx->chr) >= 0 && yyctx->yyn <= calc_TABLESIZE && calc_check[yyctx->yyn] == (calc_int_t) yyctx->chr) {
		yyctx->yyn = calc_table[yyctx->yyn];
		goto yyreduce;
	}
	if (yyctx->errflag != 0)
		goto yyinrecovery;

	calc_error(ctx, yyctx->lval, "syntax error");

	goto yyerrlab;	/* redundant goto avoids 'unused label' warning */
yyerrlab:
	++yyctx->nerrs;

yyinrecovery:
	if (yyctx->errflag < 3) {
		yyctx->errflag = 3;
		for(;;) {
			if (((yyctx->yyn = calc_sindex[*yyctx->stack.s_mark]) != 0) && (yyctx->yyn += calc_ERRCODE) >= 0 && yyctx->yyn <= calc_TABLESIZE && calc_check[yyctx->yyn] == (calc_int_t) calc_ERRCODE) {
#if calc_DEBUG
				if (yyctx->debug)
					printf("yyctx->debug: state %d, error recovery shifting to state %d\n", *yyctx->stack.s_mark, calc_table[yyctx->yyn]);
#endif
				if (yyctx->stack.s_mark >= yyctx->stack.s_last && calc_growstack(yyctx, &yyctx->stack) == calc_ENOMEM)
					goto yyoverflow;
				yyctx->state = calc_table[yyctx->yyn];
				*++yyctx->stack.s_mark = calc_table[yyctx->yyn];
				*++yyctx->stack.l_mark = yyctx->lval;
				goto yyloop;
			}
			else {
#if calc_DEBUG
				if (yyctx->debug)
					printf("yyctx->debug: error recovery discarding state %d\n", *yyctx->stack.s_mark);
#endif
				if (yyctx->stack.s_mark <= yyctx->stack.s_base)
					goto yyabort;
				--yyctx->stack.s_mark;
				--yyctx->stack.l_mark;
			}
		}
	}
	else {
		if (yyctx->chr == calc_EOF)
			goto yyabort;
#if calc_DEBUG
		if (yyctx->debug) {
			if ((yys = calc_name[calc_TRANSLATE(yyctx->chr)]) == NULL)
				yys = calc_name[calc_UNDFTOKEN];
			printf("yyctx->debug: state %d, error recovery discards token %d (%s)\n", yyctx->state, yyctx->chr, yys);
		}
#endif
		yyctx->chr = calc_EMPTY;
		goto yyloop;
	}

yyreduce:
#if calc_DEBUG
	if (yyctx->debug)
		printf("yyctx->debug: state %d, reducing by rule %d (%s)\n", yyctx->state, yyctx->yyn, calc_rule[yyctx->yyn]);
#endif
	yyctx->yym = calc_len[yyctx->yyn];
	if (yyctx->yym > 0)
		yyctx->val = yyctx->stack.l_mark[1 - yyctx->yym];
	else
		memset(&yyctx->val, 0, sizeof yyctx->val);

	switch (yyctx->yyn) {
case 3:
#line 29 "calc.y"
	{  calc_errok ; }
break;
case 4:
#line 33 "calc.y"
	{  printf("%d\n",yyctx->stack.l_mark[0]);}
break;
case 5:
#line 35 "calc.y"
	{  ctx->regs[yyctx->stack.l_mark[-2]] = yyctx->stack.l_mark[0]; }
break;
case 6:
#line 39 "calc.y"
	{  yyctx->val = yyctx->stack.l_mark[-1]; }
break;
case 7:
#line 41 "calc.y"
	{  yyctx->val = yyctx->stack.l_mark[-2] + yyctx->stack.l_mark[0]; }
break;
case 8:
#line 43 "calc.y"
	{  yyctx->val = yyctx->stack.l_mark[-2] - yyctx->stack.l_mark[0]; }
break;
case 9:
#line 45 "calc.y"
	{  yyctx->val = yyctx->stack.l_mark[-2] * yyctx->stack.l_mark[0]; }
break;
case 10:
#line 47 "calc.y"
	{  yyctx->val = yyctx->stack.l_mark[-2] / yyctx->stack.l_mark[0]; }
break;
case 11:
#line 49 "calc.y"
	{  yyctx->val = yyctx->stack.l_mark[-2] % yyctx->stack.l_mark[0]; }
break;
case 12:
#line 51 "calc.y"
	{  yyctx->val = yyctx->stack.l_mark[-2] & yyctx->stack.l_mark[0]; }
break;
case 13:
#line 53 "calc.y"
	{  yyctx->val = yyctx->stack.l_mark[-2] | yyctx->stack.l_mark[0]; }
break;
case 14:
#line 55 "calc.y"
	{  yyctx->val = - yyctx->stack.l_mark[0]; }
break;
case 15:
#line 57 "calc.y"
	{  yyctx->val = ctx->regs[yyctx->stack.l_mark[0]]; }
break;
case 17:
#line 62 "calc.y"
	{  yyctx->val = yyctx->stack.l_mark[0]; ctx->base = (yyctx->stack.l_mark[0]==0) ? 8 : 10; }
break;
case 18:
#line 64 "calc.y"
	{  yyctx->val = ctx->base * yyctx->stack.l_mark[-1] + yyctx->stack.l_mark[0]; }
break;
#line 517 "calc.c"
	}
	yyctx->stack.s_mark -= yyctx->yym;
	yyctx->state = *yyctx->stack.s_mark;
	yyctx->stack.l_mark -= yyctx->yym;
	yyctx->yym = calc_lhs[yyctx->yyn];
	if (yyctx->state == 0 && yyctx->yym == 0) {
#if calc_DEBUG
		if (yyctx->debug)
			printf("yyctx->debug: after reduction, shifting from state 0 to state %d\n", calc_FINAL);
#endif
		yyctx->state = calc_FINAL;
		*++yyctx->stack.s_mark = calc_FINAL;
		*++yyctx->stack.l_mark = yyctx->val;
		if (yyctx->chr < 0) {
			calc_GETCHAR(2);
			if (yyctx->chr < 0)
				yyctx->chr = calc_EOF;
#if calc_DEBUG
			if (yyctx->debug) {
				if ((yys = calc_name[calc_TRANSLATE(yyctx->chr)]) == NULL)
					yys = calc_name[calc_UNDFTOKEN];
				printf("yyctx->debug: state %d, reading %d (%s)\n", calc_FINAL, yyctx->chr, yys);
			}
#endif
		}
		if (yyctx->chr == calc_EOF)
			goto yyaccept;
		goto yyloop;
	}
	if (((yyctx->yyn = calc_gindex[yyctx->yym]) != 0) && (yyctx->yyn += yyctx->state) >= 0 && yyctx->yyn <= calc_TABLESIZE && calc_check[yyctx->yyn] == (calc_int_t) yyctx->state)
		yyctx->state = calc_table[yyctx->yyn];
	else
		yyctx->state = calc_dgoto[yyctx->yym];
#if calc_DEBUG
	if (yyctx->debug)
		printf("yyctx->debug: after reduction, shifting from state %d to state %d\n", *yyctx->stack.s_mark, yyctx->state);
#endif
	if (yyctx->stack.s_mark >= yyctx->stack.s_last && calc_growstack(yyctx, &yyctx->stack) == calc_ENOMEM)
		goto yyoverflow;
	*++yyctx->stack.s_mark = (calc_int_t) yyctx->state;
	*++yyctx->stack.l_mark = yyctx->val;
	goto yyloop;

yyoverflow:
	calc_error(ctx, yyctx->lval, "yacc stack overflow");

yyabort:
	calc_freestack(&yyctx->stack);
	return calc_RES_ABORT;

yyaccept:
	calc_freestack(&yyctx->stack);
	return calc_RES_DONE;
}
